/*
 * This object is a view where the game's tiles are displayed.
 * It is commonly referenced as the Game Board.
 *
 * This object has only one method, drawRect:.  In this method
 * the view is painted via the interface object which is
 * instructed to composite the game tiles.
 * All work is done by the C++ subsystem. We are mainly providing a window into the
 * graphics system.
 */

// Our superclass

#import	<Cocoa/Cocoa.h>


@interface FarmMJGameBoardView : NSView
{
    id		gameInterface;
}

- (void)dealloc;

// As a subclass of NSResponder, this object overrides the mouseDown: method such
// that click: and doubleClick: methods can be sent to the interface object.

- (void)mouseDown:(NSEvent *)theEvent;

// This object paints itself which and informs the interface object to draw the tiles.

- (void)drawRect:(NSRect)rect;
- (BOOL)isOpaque;

@end
