
#import "FarmMJGameInterface.h"


@implementation FarmMJGameInterface

- (id)init
{
    self = [super init];
    if( !self ) return nil;

    gameCoordinator		= NULL;
    tileCountManager	= NULL;

    return self;
}

- (void)dealloc
{
    delete gameCoordinator;
    delete tileCountManager;

    // <<BUG>> Ok...this is bad style. We do have a referentiol loop
    // which will prevent the release pool thing to work properly
    // but since this class lives until the end of the apps
    // live we will not force a redesing until we need it.

    [tileCountView release];
    [gameBoardView release];

    [super dealloc];
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
    [NSBundle loadNibNamed:@"GameBoard" owner:self];
    
    assert( tileCountView );
    assert( gameBoardView );

    tileCountManager = new TileCountManager( tileCountView );
    gameCoordinator = new GameCoordinator( gameBoardView, tileCountManager );

    application_initialized = YES;

    [tileCountView setNeedsDisplay:YES];
    [gameBoardView setNeedsDisplay:YES];

    [[tileCountView window] makeKeyAndOrderFront:self];
}

- (void)showInfoPanel:(id)sender;
{
    [[NSApplication sharedApplication] orderFrontObjectFarmAboutPanel:sender];
}

- (void)undoClick:(id)sender
{
   gameCoordinator->undoClick();
}

- (void)helpClick:(id)sender
{
   gameCoordinator->helpClick();
}

- (void)againClick:(id)sender
{
    gameCoordinator->againClick();
}

- (void)newClick:(id)sender
{
    gameCoordinator->newClick();
}

- (void)gameBoardDraw
{
    if( application_initialized ) gameCoordinator->drawImage();
}

- (void)click:(NSPoint)aPoint
{
    gameCoordinator->click( aPoint );
}

-(void)doubleClick:(NSPoint)aPoint
{
    gameCoordinator->doubleClick( aPoint );
}

- (void)tileCountDraw
{
    if( application_initialized ) tileCountManager->drawImage();
}

@end
