// "Legacy" C++ game engine source code...

/*
 * This object provides an array of Game Tile objects.
 *	In the application there is only one object of this class.
 */

#import	"GameTileArray.h"

#import "Tiles/EastWindTile.h"
#import "Tiles/WestWindTile.h"
#import "Tiles/NorthWindTile.h"
#import "Tiles/SouthWindTile.h"
#import <Tiles/WinterSeasonTile.h>
#import <Tiles/SpringSeasonTile.h>
#import <Tiles/SummerSeasonTile.h>
#import <Tiles/AutumnSeasonTile.h>
#import <Tiles/CircleOneTile.h>
#import <Tiles/CircleTwoTile.h>
#import <Tiles/CircleThreeTile.h>
#import <Tiles/CircleFourTile.h>
#import <Tiles/CircleFiveTile.h>
#import <Tiles/CircleSixTile.h>
#import <Tiles/CircleSevenTile.h>
#import <Tiles/CircleEightTile.h>
#import <Tiles/CircleNineTile.h>
#import <Tiles/BambooOneTile.h>
#import <Tiles/BambooTwoTile.h>
#import <Tiles/BambooThreeTile.h>
#import <Tiles/BambooFourTile.h>
#import <Tiles/BambooFiveTile.h>
#import <Tiles/BambooSixTile.h>
#import <Tiles/BambooSevenTile.h>
#import <Tiles/BambooEightTile.h>
#import <Tiles/BambooNineTile.h>
#import <Tiles/CharacterOneTile.h>
#import <Tiles/CharacterTwoTile.h>
#import <Tiles/CharacterThreeTile.h>
#import <Tiles/CharacterFourTile.h>
#import <Tiles/CharacterFiveTile.h>
#import <Tiles/CharacterSixTile.h>
#import <Tiles/CharacterSevenTile.h>
#import <Tiles/CharacterEightTile.h>
#import <Tiles/CharacterNineTile.h>
#import <Tiles/WhiteTile.h>
#import <Tiles/RedTile.h>
#import	<Tiles/GreenTile.h>
#import <Tiles/BambooTile.h>
#import <Tiles/PlumTile.h>
#import <Tiles/OrchidTile.h>
#import <Tiles/ChrysanthemumTile.h>

#import	<assert.h>

GameTileArray::GameTileArray( void )
{
    // Build the table of Game Tiles.
    // (Could be done much more efficiently but C++ doesn't support aggregate
    // initialization.)
    
	int				i = 0, j;
	
	assert( NUMBER_OF_TILES == 144 );
	
	for( j = 0; j < NUMBER_OF_EAST_WIND; ++j, ++i )
		game_tiles[ i ] = new EastWindTile;
	for( j = 0; j < NUMBER_OF_WEST_WIND; ++j, ++i )
		game_tiles[ i ] = new WestWindTile;
	for( j = 0; j < NUMBER_OF_NORTH_WIND; ++j, ++i )
		game_tiles[ i ] = new NorthWindTile;
	for( j = 0; j < NUMBER_OF_SOUTH_WIND; ++j, ++i )
		game_tiles[ i ] = new SouthWindTile;
	for( j = 0; j < NUMBER_OF_WINTER_SEASON; ++j, ++i )
		game_tiles[ i ] = new WinterSeasonTile;
	for( j = 0; j < NUMBER_OF_SPRING_SEASON; ++j, ++i )
		game_tiles[ i ] = new SpringSeasonTile;
	for( j = 0; j < NUMBER_OF_SUMMER_SEASON; ++j, ++i )
		game_tiles[ i ] = new SummerSeasonTile;
	for( j = 0; j < NUMBER_OF_AUTUMN_SEASON; ++j, ++i )
		game_tiles[ i ] = new AutumnSeasonTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_1; ++j, ++i )
		game_tiles[ i ] = new CircleOneTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_2; ++j, ++i )
		game_tiles[ i ] = new CircleTwoTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_3; ++j, ++i )
		game_tiles[ i ] = new CircleThreeTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_4; ++j, ++i )
		game_tiles[ i ] = new CircleFourTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_5; ++j, ++i )
		game_tiles[ i ] = new CircleFiveTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_6; ++j, ++i )
		game_tiles[ i ] = new CircleSixTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_7; ++j, ++i )
		game_tiles[ i ] = new CircleSevenTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_8; ++j, ++i )
		game_tiles[ i ] = new CircleEightTile;
	for( j = 0; j < NUMBER_OF_CIRCLE_9; ++j, ++i )
		game_tiles[ i ] = new CircleNineTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_1; ++j, ++i )
		game_tiles[ i ] = new BambooOneTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_2; ++j, ++i )
		game_tiles[ i ] = new BambooTwoTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_3; ++j, ++i )
		game_tiles[ i ] = new BambooThreeTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_4; ++j, ++i )
		game_tiles[ i ] = new BambooFourTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_5; ++j, ++i )
		game_tiles[ i ] = new BambooFiveTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_6; ++j, ++i )
		game_tiles[ i ] = new BambooSixTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_7; ++j, ++i )
		game_tiles[ i ] = new BambooSevenTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_8; ++j, ++i )
		game_tiles[ i ] = new BambooEightTile;
	for( j = 0; j < NUMBER_OF_BAMBOO_9; ++j, ++i )
		game_tiles[ i ] = new BambooNineTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_1; ++j, ++i )
		game_tiles[ i ] = new CharacterOneTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_2; ++j, ++i )
		game_tiles[ i ] = new CharacterTwoTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_3; ++j, ++i )
		game_tiles[ i ] = new CharacterThreeTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_4; ++j, ++i )
		game_tiles[ i ] = new CharacterFourTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_5; ++j, ++i )
		game_tiles[ i ] = new CharacterFiveTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_6; ++j, ++i )
		game_tiles[ i ] = new CharacterSixTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_7; ++j, ++i )
		game_tiles[ i ] = new CharacterSevenTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_8; ++j, ++i )
		game_tiles[ i ] = new CharacterEightTile;
	for( j = 0; j < NUMBER_OF_CHARACTER_9; ++j, ++i )
		game_tiles[ i ] = new CharacterNineTile;
	for( j = 0; j < NUMBER_OF_RED; ++j, ++i )
		game_tiles[ i ] = new RedTile;
	for( j = 0; j < NUMBER_OF_GREEN; ++j, ++i )
		game_tiles[ i ] = new GreenTile;
	for( j = 0; j < NUMBER_OF_WHITE; ++j, ++i )
		game_tiles[ i ] = new WhiteTile;
	for( j = 0; j < NUMBER_OF_BAMBOO; ++j, ++i )
		game_tiles[ i ] = new BambooTile;
	for( j = 0; j < NUMBER_OF_PLUM; ++j, ++i )
		game_tiles[ i ] = new PlumTile;
	for( j = 0; j < NUMBER_OF_ORCHID; ++j, ++i )
		game_tiles[ i ] = new OrchidTile;
	for( j = 0; j < NUMBER_OF_MUM; ++j, ++i )
		game_tiles[ i ] = new ChrysanthemumTile;
	assert( i == NUMBER_OF_TILES );
}

GameTileArray::~GameTileArray( void )
{
	for( int i = 0; i < NUMBER_OF_TILES; ++i )
		delete game_tiles[ i ];
}

GameTile& GameTileArray::operator[]( int loc )
{
	assert( loc >= 0 && loc < NUMBER_OF_TILES );
	return *game_tiles[ loc ];
}

void GameTileArray::swap( int i, int j)
{
	GameTile*	temp;
	
	assert( i >= 0 && i < NUMBER_OF_TILES );
	assert( j >= 0 && j < NUMBER_OF_TILES );

	temp = game_tiles[ j ];
	game_tiles[ j ] = game_tiles[ i ];
	game_tiles[ i ] = temp;
}

int GameTileArray::size( void )
{
	return NUMBER_OF_TILES;
}