// "Legacy" C++ game engine source code...

// Our class
#import	"IntegerList.h"

// System frameworks
#import	<Cocoa/Cocoa.h>


IntegerList::IntegerList( void )
{
    my_list = [[NSMutableArray alloc] init];
    iterator = 0;
}

IntegerList::~IntegerList( void )
{
    [my_list release];
}

int IntegerList::operator()()
{
    int	rVal = -1;

    if( (int)[my_list count] > iterator )
        rVal = [[my_list objectAtIndex:iterator++] intValue];

return rVal;
}

void IntegerList::beginIterate( void )
{
    iterator = 0;
}

void IntegerList::operator+=( int integer )
{
    [my_list addObject:[NSNumber numberWithInt:integer]];
}

void IntegerList::operator-=( int integer )
{
    [my_list removeObject:[NSNumber numberWithInt:integer]];
}

void IntegerList::empty( void )
{
    [my_list release];
    my_list = [[NSMutableArray alloc] init];
}

int IntegerList::count( void )
{
    return [my_list count];
}

int IntegerList::lastValue( void )
{
    return count() == 0 ? -1 : [[my_list lastObject] intValue];
}