// "Legacy" C++ game engine source code...

#import	"Tile.h"


Tile::Tile( void )
{
	my_tile_image = nil;
}

Tile::~Tile( void )
{
	[my_tile_image release];
}

void Tile::loadImageFromFile( const char* aFile )
{
    if( my_tile_image != nil ) [my_tile_image autorelease];
	my_tile_image = [[NSImage imageNamed:[NSString stringWithCString:aFile]] retain];
}

void Tile::compositeImage( NSPoint aPoint, int aMode )
{
    // <<NOTE>> We might cache the Tile background images to speed up drawing...
   
    if( aMode == TILEIMAGE_OVER_NORMALBASE )
        [[NSImage imageNamed:@"Tile"] compositeToPoint:aPoint operation:NSCompositeSourceOver];

    else if( aMode == TILEIMAGE_OVER_HIGHLITEDBASE)
        [[NSImage imageNamed:@"TileH"] compositeToPoint:aPoint operation:NSCompositeSourceOver];

    // If we are composing on top of a base tile we need to shift the image.
    // This is basically a hack to get the number tles working.
    
    if( aMode != TILEIMAGE_ONLY )
    {
       aPoint.x += 2;
       aPoint.y += 6;
    }
    [my_tile_image compositeToPoint:aPoint operation:NSCompositeSourceOver];
}